/*
 * shm-client - client program to demonstrate shared memory.
 */
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include <stdlib.h>
#include "structs.h"

int main( int argc, char * argv[])
{
    int shmid;
    key_t key;
    char *shm, *s;

    char message[255];

    mem_region * region;

    /*
     * We need to get the segment named
     * "1234", created by the server.
     */
    key = 1234;

    /*
     * Locate the segment.
     */
    if ((shmid = shmget(key, SHMSZ, 0666)) < 0) {
        perror("shmget");
        exit(1);
    }

    /*
     * Now we attach the segment to our data space.
     */
    if ((shm = shmat(shmid, NULL, 0)) == (char *) -1) {
        perror("shmat");
        exit(1);
    }

    region = (mem_region *)shm;

    while (region->status != TERMINATED) { 
	//espera activa
	while (region->status != SERVER_SENT);
	strcpy(message, region->message);
	printf("%s\n", message);
	sprintf(region->message, "\tClient: You sent: %s", message);
	region->status = CLIENT_SENT;
    }

    exit(0);
}


